import java.util.concurrent.*;

abstract class Production extends Thread {

	Production(Vertex Vert,CyclicBarrier Count){
		m_vertex = Vert;
		m_counter = Count;
		m_drawer = new GraphDrawer();
	}

	//returns first vertex from the left
	abstract Vertex apply(Vertex v);

	//run the thread
	public void run() {
		//apply the production
		m_vertex = apply(m_vertex);
		//plot the graph
		//m_drawer.draw(m_vertex);
		try {
            m_counter.await();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
	}

	//vertex where the production will be applied
	Vertex m_vertex;
	//graph drawer
	GraphDrawer m_drawer;
	//productions counter
	CyclicBarrier m_counter;
}

class P1 extends Production {
	P1(Vertex Vert,CyclicBarrier Count){
		super(Vert,Count);
	}
	Vertex apply(Vertex S) {
	  System.out.println("p1");
	  Vertex T1 = new Vertex(null,null,S,"T");
	  Vertex T2 = new Vertex(null,null,S,"T");
	  S.set_left(T1);
	  S.set_right(T2);
	  S.set_label("root");
	  return S;
	}
}

class P2 extends Production {
    P2(Vertex vert, CyclicBarrier count) {
        super(vert, count);
    }
    Vertex apply(Vertex S) {
	  System.out.println("p2");
	  Vertex T1 = new Vertex(null,null,S,"T");
	  Vertex T2 = new Vertex(null,null,S,"T");
	  S.set_left(T1);
	  S.set_right(T2);
	  S.set_label("Int");
	  return S;
	}
}

class P3 extends Production {
    P3(Vertex vert, CyclicBarrier count) {
        super(vert, count);
    }
    Vertex apply(Vertex S) {
	  System.out.println("p3");
	  Vertex T1 = new Vertex(null,null,S,"node");
	  Vertex T2 = new Vertex(null,null,S,"node");
	  S.set_left(T1);
	  S.set_right(T2);
	  S.set_label("Int");
	  return S;
	}
}

