import java.util.concurrent.*;

class A extends Production {
    public static double[] previousSolution;
    
    A(Vertex Vert,CyclicBarrier Count, double a0, double a1){
        super(Vert,Count);
        this.a0 = a0;
        this.a1 = a1;
    }
    Vertex apply(Vertex T) {
        System.out.println("A");
        
        double h = Executor.h;
        double dt = Executor.dt;
        
        T.m_a[2][2]=h/3.0;
        T.m_a[4][2]=h/6.0;
        T.m_a[2][4]=h/6.0;
        T.m_a[4][4]=h/3.0;
        T.m_a[3][3] = 1.0;
        T.m_b[2]=a0*h/3.0 + a1*h/6.0 - dt*(a0/h - a1/h);
        T.m_b[4]=a0*h/6.0 + a1*h/3.0 - dt*(-a0/h + a1/h);
        T.m_b[3] = 0.0;
        
        /*T.m_a[2][2] = -1;
        T.m_a[3][3] = 1;
        T.m_a[4][4] = -1;
        T.m_a[4][2] = 1;
        T.m_a[2][4] = 1;*/
        return T;
    }
    
    double a0, a1;
}

class A00 extends Production {
    A00(Vertex Vert,CyclicBarrier Count){
        super(Vert,Count);
    }
    Vertex apply(Vertex T) {
        System.out.println("A");
        return T;
    }
}

class A01 extends Production {
    A01(Vertex Vert,CyclicBarrier Count){
        super(Vert,Count);
    }
    Vertex apply(Vertex T) {
        System.out.println("A");
        
        double h = Executor.h;
        double dt = Executor.dt;
        
        T.m_a[4][4] = 1.0;
        T.m_b[4] = 0.0;
        return T;
    }
}


class A1 extends Production {
    A1(Vertex Vert,CyclicBarrier Count, double a0, double a1){
        super(Vert,Count);
        this.a0 = a0;
        this.a1 = a1;
    }
    Vertex apply(Vertex T) {
        System.out.println("A1");
        
        double h = Executor.h;
        double dt = Executor.dt;
        
        T.m_a[2][2]=h/3.0;
        T.m_a[4][2]=h/6.0;
        T.m_a[2][4]=h/6.0;
        T.m_a[4][4]=h/3.0;
        T.m_a[3][3]=1.0;
        T.m_b[2]=a0*h/3.0 + a1*h/6.0 - dt*(a0/h - a1/h - 1 + a0);
        T.m_b[4]=a0*h/6.0 + a1*h/3.0 - dt*(-a0/h + a1/h);
        return T;
    }
    
    double a0, a1;
}
class AN extends Production {
    AN(Vertex Vert,CyclicBarrier Count, double a0, double a1){
        super(Vert,Count);
        this.a0 = a0;
        this.a1 = a1;
    }
    Vertex apply(Vertex T) {
        System.out.println("AN");
        
        double h = Executor.h;
        double dt = Executor.dt;
        
        T.m_a[2][2]=h/3.0;
        T.m_a[4][2]=h/6.0;
        T.m_a[2][4]=h/6.0;
        T.m_a[4][4]=h/3.0;
        T.m_a[3][3]=1.0;
        T.m_b[2]=a0*h/3.0 + a1*h/6.0 - dt*(a0/h - a1/h);
        T.m_b[4]=a0*h/6.0 + a1*h/3.0 - dt*(-a0/h + a1/h + 1 + a1);
        
        /*T.m_a[2][2] = -1;
        T.m_a[3][3] = 1;
        T.m_a[4][4] = 1;
        T.m_a[2][4] = 1;
        T.m_b[4] = 1;*/
        return T;
    }
    
    double a0, a1;
}

class A2 extends Production {
    A2(Vertex Vert,CyclicBarrier Count){
        super(Vert,Count);
    }
    synchronized Vertex apply(Vertex T) {
        System.out.println("A2");
        
        for(int i = 2; i < 6; ++i) {
            for (int j = 2; j < 6; ++j) {
                T.m_a[i][j] = T.m_left.m_a[i][j] + T.m_right.m_a[i-1][j-1];
            }
            T.m_b[i] = T.m_left.m_b[i] + T.m_right.m_b[i-1];
        }
        return T;
    }
}


class E2 extends Production {
    E2(Vertex Vert,CyclicBarrier Count){
        super(Vert,Count);
    }
    Vertex apply(Vertex T) {
        System.out.println("E2");
        /*T.m_b[0] /= T.m_a[0][0];
        T.m_a[0][2] /= T.m_a[0][0];
        T.m_a[0][1] /= T.m_a[0][0];
        T.m_a[0][0] /= T.m_a[0][0];
        T.m_b[1] -= T.m_b[0] * T.m_a[1][0];
        T.m_a[1][2] -= T.m_a[0][2] * T.m_a[1][0];
        T.m_a[1][1] -= T.m_a[0][1] * T.m_a[1][0];
        T.m_a[1][0] -= T.m_a[0][0] * T.m_a[1][0];
        T.m_b[2] -= T.m_b[0] * T.m_a[2][0];
        T.m_a[2][2] -= T.m_a[0][2] * T.m_a[2][0];
        T.m_a[2][1] -= T.m_a[0][1] * T.m_a[2][0];
        T.m_a[2][0] -= T.m_a[0][0] * T.m_a[2][0];*/
        return T;
    }
}

class A3 extends Production {
    A3(Vertex vert, CyclicBarrier count) {
        super(vert, count);
    }
    
    Vertex apply(Vertex T) {
        System.out.println("A3");
        
        int swapped_rows[] = { 2, 3, 0, 1, 4, 5 };
        
        for(int i = 2; i < 6; ++i) {
            for(int j = 2; j < 6; ++j) {
                T.m_a[swapped_rows[i-2]][swapped_rows[j-2]] += T.m_left.m_a[i][j];
                T.m_a[swapped_rows[i]][swapped_rows[j]] += T.m_right.m_a[i][j];
            }
            T.m_b[swapped_rows[i-2]] += T.m_left.m_b[i];
            T.m_b[swapped_rows[i]] += T.m_right.m_b[i];
        }
        
        return T;
    }
}

class E3 extends Production {
    E3(Vertex vert, CyclicBarrier count) {
        super(vert, count);
    }
    
    void eliminate_row(int r, int c, Vertex T)
    {
        T.m_b[r] /= T.m_a[r][c];
        for(int j = c+1; j < 6; ++j)
            T.m_a[r][j] /= T.m_a[r][c];
        T.m_a[r][c] /= T.m_a[r][c];
        
        for (int i = r+1; i < 6; ++i)
        {
            if (i == r)
                continue;
            T.m_b[i] -= T.m_b[r]*T.m_a[i][c];
            for (int j = c+1; j < 6; ++j)
                T.m_a[i][j] -= T.m_a[r][j]*T.m_a[i][c];
            T.m_a[i][c] -= T.m_a[r][c]*T.m_a[i][c];
        }
    }
    
    Vertex apply(Vertex T) {
        System.out.println("E3");
        
        eliminate_row(0, 0, T);
        eliminate_row(1, 1, T);
        T.m_x[0] = T.m_b[0];
        T.m_x[1] = T.m_b[1];
        
        return T;
    }
}

class Aroot extends A3 {
    Aroot(Vertex Vert,CyclicBarrier Count){
        super(Vert,Count);
    }
}

class Eroot extends E3 {
    Eroot(Vertex Vert,CyclicBarrier Count){
        super(Vert,Count);
    }
    Vertex apply(Vertex T) {
        System.out.println("Eroot");
        
        for(int i = 0; i < 6; ++i)
            eliminate_row(i, i, T);
            
        T.m_x[5] = T.m_b[5];
        for (int i = 4; i >= 0; --i) {
            T.m_x[i] = T.m_b[i];
            for (int j = i+1; j < 6; ++j)
                T.m_x[i] -= T.m_x[j]*T.m_a[i][j];
        }
        
        return T;
    }
}
class BS1 extends Production {
    BS1(Vertex Vert,CyclicBarrier Count){
        super(Vert,Count);
    }
    Vertex apply(Vertex T) {
        System.out.println("BS");
        if (T.m_label.equals("node")) 
            return T;
            
        int swapped_rows[] = { 2, 3, 0, 1, 4, 5 };
        
        T.m_x[1] = T.m_b[1] - T.m_x[2]*T.m_a[1][2] - T.m_x[3]*T.m_a[1][3] - T.m_x[4]*T.m_a[1][4] - T.m_x[5]*T.m_a[1][5];
        T.m_x[0] = T.m_b[0] - T.m_x[1]*T.m_a[0][1] - T.m_x[2]*T.m_a[0][2] - T.m_x[3]*T.m_a[0][3] - T.m_x[4]*T.m_a[0][4] - T.m_x[5]*T.m_a[0][5];
        
        for(int i = 2; i < 6; ++i)
        {
            T.m_left.m_x[i] = T.m_x[swapped_rows[i-2]];
            T.m_right.m_x[i] = T.m_x[swapped_rows[i]];
        }
            
        return T;
    }
}

class BS2 extends Production {
    BS2(Vertex Vert,CyclicBarrier Count){
        super(Vert,Count);
    }
    Vertex apply(Vertex T) {
        System.out.println("BS2");
        if (T.m_label.equals("node")) 
            return T;
        
        for(int i = 2; i < 6; ++i) {
            T.m_left.m_x[i] = T.m_x[i];
            T.m_right.m_x[i-1] = T.m_x[i];
        }
            
        return T;
    }
}

